const Base = require("../class/Base");
const Registry = require("@tars/registry");

class Sys extends Base {
  constructor() {
    super();
    this._registry = Registry.New();
  }

  // servant => ['ip1:port1', 'ip2:port2']
  async getAllAddrsByServant(servant) {
    if (!process.env.TAF_CONFIG) {
      let rsp = await require("tx-report-servant").getAllAddrsByServant(
        servant,
      );
      return rsp.addrs;
    } else {
      let locator =
        require("@tars/rpc").server.communicator.getProperty("locator");
      if (!this._loacator) {
        this._loacator = locator;
        this._registry.setLocator(locator);
      } else {
        if (this._loacator != locator) {
          this._loacator = locator;
          this._registry.resetLocator(locator);
        }
      }
      let eps = await this._registry.findObjectById4All(servant);
      let actives = [];
      let res = [];
      let endpoints = eps.response.arguments.activeEp;
      for (i = 0, len = endpoints.value.length; i < len; i++) {
        actives.push(`${endpoints.value[i].host}:${endpoints.value[i].port}`);
      }
      res.push(actives);
      return res;
    }
  }
}

module.exports = Sys;
